#!/usr/bin/perl
# 
#########################################
# adstimesync
# 
# version 0.1		24/10/2005
#
######################################### 
# Ce script sert  maintenir la synchronisation de l'horloge de la machine locale
# avec le serveur Active Directory.
# En cas de dcalage trop important (par dfaut plus de 3 minutes)
# l'authentification devient impossible.
# 
########################################

use strict;
use warnings;

########################################
# configuration
my $smbconf = '/etc/samba/smb.conf';
my $krb5conf =  '/etc/krb5.conf';

# commande externe de synchro horaire : redirige pour viter les mails  root
my $timecommand =  "/usr/bin/net time -S SERVER set  > /dev/null";

########################################
# fonctions

sub get_krbservname {
	# USAGE : get_krbservname(<krb5.conf file>)
	# returns krb server FQDN name
	my $conffile = shift;
	
	# valeur  retourner
	my $krbserv;
	
	open my $fh, $conffile
		or die "impossible d'ouvrir krb5.conf! : $!";

	KRBCONF: while (<$fh>) {
		# ignorer les commentaires
		next if m/^#/;
		
		if ( m/kdc\s*=\s*([\w\.\-]+)/ ) {
			$krbserv = $1;	
			last KRBCONF;	
		}
	}
	
	return $krbserv;
}
 

########################################
# principal

exit unless ( -e $smbconf );
exit unless ( -e $krb5conf );

# recherche param dans smb.conf
open my $fhsmb, $smbconf 
	or die "Impossible d'ouvrir smb.conf! : $!";
	
SMBCONF: while ( <$fhsmb> ) {
	# ignorer les commentaires
	next if m/^;/;

	if ( m/security\s*=\s*ads/i ) {
		# rcuprer le nom du serveur kerberos
		my $krbserv = get_krbservname($krb5conf) 
			# attention au $_ dans le call!
			or die "Erreur de configuration krb5.conf.";
		
		# prparation de la commande
		$timecommand =~ s/SERVER/$krbserv/;
		
		# synchroniser sur le serveur kerberos
		system($timecommand) == 0
			or die "Synchronisation choue.";
		
		last SMBCONF;
	}
}

# Fin.
